using System;
using System.Collections.Generic;
using System.Linq;
using KnigolubAvalonia.Data;
using KnigolubAvalonia.Models;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;

namespace KnigolubAvalonia.ViewModels
{
	public class AboutInvoiceViewModel : ReactiveObject
	{
		Invoice currentInvoice;
        string newInvoice;

        public Invoice CurrentInvoice { get => currentInvoice; set => this.RaiseAndSetIfChanged(ref currentInvoice, value); }

        public AboutInvoiceViewModel(int idInvoice)
        {
            this.currentInvoice = GlobalData.DbConnection.Invoices
                .Include(x => x.IdProviderNavigation)
                .Include(x => x.IdPaymentNavigation)
                .Include(x => x.IdReceiptNavigation)
                .FirstOrDefault(x=>x.Id==idInvoice);
            newInvoice = "false";
        }

        public AboutInvoiceViewModel()
        {
            this.currentInvoice = new();
            newInvoice = "true";
        }

        public bool SaveInvoice()
        {
            try
            {
                if (newInvoice == "true")
                {
                    GlobalData.DbConnection.Invoices.Add(CurrentInvoice);
                    GlobalData.DbConnection.SaveChanges();
                }
                else
                {
                    GlobalData.DbConnection.SaveChanges();
                }
                return true;
            }
            catch
            {
                return false;
            }

        }
    }
}