using System;
using KnigolubAvalonia.Data;
using KnigolubAvalonia.Models;
using ReactiveUI;

namespace KnigolubAvalonia.ViewModels;

public class AboutProviderVM: ViewModelBase
{
    private Provider currentProvider = new();

    string showInvoice = "false";
    string notNewProvider = "false";
    public Provider CurrentProvider
    {
        get => currentProvider;
        set => this.RaiseAndSetIfChanged(ref currentProvider, value);
    }
    public string ShowInvoice { get => showInvoice; set => this.RaiseAndSetIfChanged(ref showInvoice, value); }
    public string NotNewProvider { get => notNewProvider; set => this.RaiseAndSetIfChanged(ref notNewProvider, value); }

    public AboutProviderVM()
    {
        ShowInvoice = "false";
        NotNewProvider = "false";
        currentProvider = new();
    }

    public AboutProviderVM(Provider currentProvider)
    {
        CurrentProvider = currentProvider;
        ShowInvoice = "false";
        NotNewProvider = "true";
    }

    public bool SaveProvider()
    {
        try
        {
            if (NotNewProvider == "true")
            {
                GlobalData.DbConnection.SaveChanges();
            }
            else
            {
                GlobalData.DbConnection.Providers.Add(CurrentProvider);
                GlobalData.DbConnection.SaveChanges();
            }
            return true;
        }
        catch
        {
            return false;
        }
        
    }

}