using System.Collections.Generic;
using System.Linq;
using KnigolubAvalonia.Data;
using KnigolubAvalonia.Models;
using KnigolubAvalonia.Views;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;

namespace KnigolubAvalonia.ViewModels;

public class ProviderVM : ViewModelBase
{
    private List<Provider> providers = GlobalData.DbConnection.Providers
        .Include(x => x.Invoices)
        .ToList();

    public List<Provider> Providers
    {
        get => providers ;
        //для обновления и данных, и формы
        set => this.RaiseAndSetIfChanged(ref providers, value);
    }

    public void DeleteProvider(int id)
    {
        GlobalData.DbConnection.Providers.Remove(providers.FirstOrDefault(x => x.Id == id));
        GlobalData.DbConnection.SaveChanges();
        Providers = GlobalData.DbConnection.Providers
        .Include(x => x.Invoices)
        .ToList();
    }
}